const
   CR      = #13;    { carriage return }
   LF      = #10;    { line feed       }
   FF      = #12;    { form feed       }
   ESC     = #27;    { escape          }
   BEL     = #7;     { bell            }
   DEL     = #127;   { delete          }
   NUL     = #0;     { nothing char    }
   SPC     = #32;    { blank space     }
   BS      = #8;     { back space      }
   UP      = #199;   { up arrow        }
   DOWN    = #207;   { down arrow      }
   RIGHT   = #204;   { right arrow     }
   LEFT    = #202;   { left arrow      }
   HOME    = #198;   { home key        }
   END_KEY = #206;   { end key         }
   PG_UP   = #200;   { page up         }
   PG_DOWN = #208;   { page down       }

type
   Str80 = string[80];
   Str20 = string[20];
   CharSet = set of char;
   RegRec = record           { 8088 CPU registers type definition }
               case boolean of
               TRUE  : (AX,BX,CX,DX,BP,SI,DI,DS,ES, FLAGS : integer );
               FALSE : (AL, AH, BL, BH, CL, CH, DL, DH    : byte    );
            end; { Reg Rec }


{$I DrawBox.inc  }
{$I IntWindo.inc }
{$I GetCh.inc    }
{$I Select.inc   }
{$I TxtColor.inc }
{$I HexStr.inc   }



procedure AsciiTable;
   const
      Desc : array [0..32] of string[3] =
             ('NUL','SOH','STX','ETX','EOT','ENQ','ACK','BEL','BS','HT',
              'LF','VT','FF','CR','SO','SI','DLE','DC1','DC2','DC3',
              'DC4','NAK','SYN','ETB','CAN','EM','SUB','ESC','FS','GS',
              'RS','US','SPC');
      PG : byte = 1;
   var
      Ch  : char;
   procedure ShowPage( P : byte );
      var
         loop  : byte;
      begin
      ClrScr;
      for loop := (16 * P)-16 to (P * 16) do
         begin
         if (Odd(loop)) then
            TxtColor(LightGray,Black)
         else
            TxtColor(Yellow,Black);
         write(loop:4);
         write(HexStr(loop):5);
         if not (loop in [7,8,10,13]) then
            write(Chr(loop):4,' ')
         else
            write('':5);
         if (loop in [0..32]) then
            write(DESC[loop]:5)
         else
            writeln;
         end;
      end;
   begin
   OpenWindo(55,1,55+22,24,'ASCII table',White,Blue);
   writeln(' DEC  HEX  IMG  DESC');
   write  (' ---  ---  ---  ----');
   gotoxy(1,21);
   writeln('Page UP/DOWN':16);
   write('ESC = Exit':16);
   window(56,4,56+18,21);
   repeat
      begin
      ShowPage(PG);
      Select(1,WhereY,'',[ESC,PG_UP,PG_DOWN],Ch);
      case (Ch) of
         PG_UP   : if (PG = 1) then
                      PG := 16
                   else
                      PG := pred(PG);
         PG_DOWN : if (PG = 16) then
                      PG := 1
                   else
                      PG := succ(PG);
         end; { case }
      end;
   until (Ch = ESC);
   CloseWindo;
   end;  { Ascii Table }

begin
AsciiTable;
end.

