procedure Calculator; { Nov. 9, 1986 }
   const
      HEX_MODE : boolean = FALSE;
      FRACTION : boolean = FALSE;
      DIV_ZERO : boolean = FALSE;
      NUM      : real    = 0.0;
      TMP_NUM  : real    = 0.0;
      MEM_NUM  : real    = 0.0;
      MULTIPLY : real    = 1.0;
      OP_CHAR  : char    = #0;
      BASE     : array [Boolean] of real = (10.0,16.0);
   var
      ChrVal  : byte;
      Ch      : char;
   procedure DrawCalculator;
      begin
      OpenWindo(55,1,80,17,'Calculator',Black,LightGray);
      DrawBox(2,1,23,3);
      gotoxy(1,5);
      writeln('   7 8 9   +  Add');
      writeln('   4 5 6   -  Subtract');
      writeln('   1 2 3   *  Multiply');
      writeln('   0       /  Divide',LF);
      writeln('  <PF1> = Clear');
      writeln('  <PF2> = Clear Memory');
      writeln('  <S>   = Set Memory');
      writeln('  <R>   = Recall Memory');
      writeln('  <H>   = Hex ON/OFF');
      write  ('  <ESC> = Quit');
      end; { draw }
   procedure Display( N : real );
      var
         TmpStr : string[21];
      begin
      if (DIV_ZERO) then
         TmpStr := 'DIV BY 0 !'
      else
         begin
         if (HEX_MODE) then
            TmpStr := HexStr(N)
         else
            Str(N:1:4,TmpStr);
         end;
      if (Length(TmpStr) > 11) then
          TmpStr[0] := chr(11);
      gotoxy(4,2);
      if (MEM_NUM = 0.0) then
         write('':2)
      else
         write('M ');
      if (HEX_MODE) then
         write('HEX')
      else
         write('':3);
      write(OP_CHAR,TmpStr:12);
      end; { Display }
   procedure ClearAll;
      begin
      FRACTION := FALSE;
      DIV_ZERO := FALSE;
      ChrVal   := 0;
      OP_CHAR  := NUL;
      MULTIPLY := 1.0;
      TMP_NUM  := 0.0;
      NUM      := 0.0;
      end;
   procedure DoCalc;
      begin
      case (OP_CHAR) of
         '+' : TMP_NUM := (TMP_NUM + NUM);
         '-' : TMP_NUM := (TMP_NUM - NUM);
         '*' : TMP_NUM := (TMP_NUM * NUM);
         '/' : begin
               DIV_ZERO := (NUM = 0.0);
               if not (DIV_ZERO) then
                  TMP_NUM := (TMP_NUM / NUM);
               end;
         else
            TMP_NUM := NUM;
         end;
      NUM      := 0.0;
      Fraction := FALSE;
      MULTIPLY := 1.0;
      OP_CHAR  := NUL;
      end;  { Do Calculation }
   begin  { main of calculator }
   DrawCalculator;
   Display(NUM);
   repeat
      begin
      Ch := upcase(GetCh(Ch));
      case (Ch) of
         LF      : Ch := '1';
         END_KEY : Ch := '2';
         PG_DOWN : Ch := '3';
         LEFT    : Ch := '4';
         DOWN    : Ch := '5';
         RIGHT   : Ch := '6';
         HOME    : Ch := '7';
         UP      : Ch := '8';
         PG_UP   : Ch := '9';
         end;
      case (Ch) of
         'A'..'F',
         '0'..'9'  : begin { value character }
                     ChrVal := pred(pos(Ch,'0123456789ABCDEF'));
                     if (FRACTION) and not (HEX_MODE) then
                        begin
                        MULTIPLY := (MULTIPLY / 10.0);
                        NUM      := (NUM + (ChrVal * MULTIPLY));
                        end
                     else
                        NUM := ((NUM * BASE[HEX_MODE]) + ChrVal);
                     end;  { value character }
         PF1       : ClearAll;
         PF2       : MEM_NUM  := 0.0;
         '.'       : Fraction := TRUE;
         'H'       : HEX_MODE := not (HEX_MODE);
         '+','-',
         '*','/'   : begin
                     DoCalc;
                     Display(TMP_NUM);
                     OP_CHAR := Ch;
                     end;
         '='       : begin
                     DoCalc;
                     NUM := TMP_NUM;
                     end;
         'S'       : MEM_NUM := NUM;
         'R'       : NUM := MEM_NUM;
         end; { case Ch }
      if (Ch in ['A'..'F','0'..'9',PF1,PF2,'H','=','S','R']) then
         Display(NUM);
      end;
   until (Ch = ESC);
   CloseWindo;
   end;   { main of calculator }