{ Calendar development }

const
   CR      = #13;    { carriage return }
   LF      = #10;    { line feed       }
   FF      = #12;    { form feed       }
   ESC     = #27;    { escape          }
   BEL     = #7;     { bell            }
   DEL     = #127;   { delete          }
   NUL     = #0;     { nothing char    }
   SPC     = #32;    { blank space     }
   BS      = #8;     { back space      }
   UP      = #199;   { up arrow        }
   DOWN    = #207;   { down arrow      }
   RIGHT   = #204;   { right arrow     }
   LEFT    = #202;   { left arrow      }
   HOME    = #198;   { home key        }
   END_KEY = #206;   { end key         }
   PG_UP   = #200;   { page up         }
   PG_DOWN = #208;   { page down       }

type
   Str80  = string[80];
   RegRec = record           { 8088 CPU registers type definition }
               case boolean of
               TRUE  : (AX,BX,CX,DX,BP,SI,DI,DS,ES, FLAGS : integer );
               FALSE : (AL, AH, BL, BH, CL, CH, DL, DH    : byte    );
            end; { Reg Rec }

{$I DrawBox.inc  }
{$I MemWindo.inc }
{$I GetDate.inc  }
{$I SetDate.inc  }
{$I MaxDays.inc  }
{$I GetCh.inc    }
{$I TxtColor.inc }


procedure Calendar;
   const
      MONTH : byte    = 0;
      DAY   : byte    = 0;
      YEAR  : integer = 0;
      MONTH_STR : array [1..12] of string[3] = ('Jan','Feb','Mar','Apr',
                        'May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
      DAY_STR   : array [0..6] of string[9]  = ('Sunday','Monday','Tuesday',
                        'Wednesday','Thursday','Friday','Saturday');
      CH : char = ESC;
   var
      M, D, W   : byte;
      Y         : integer;
      FuncKey   : boolean;

   procedure DrawGrid;
      var
         line : string[28];
      begin
      FillChar(line[1],28,#196);
      line[0] := chr(28);
      gotoxy(1,2);
      write('Sun Mon Tue Wed Thu Fri Sat ');
      write(line);
      gotoxy(1,10);
      write(line);
      writeln('  U/D arrow  =  +/- Month');
      writeln('  R/L arrow  =  +/- Day');
      writeln('  PG U/D key =  +/- Year');
      write  ('  <ESC> exit   <S> set date');
      end; { Draw Grid }

   procedure DrawDays( Mo, Da : byte; Ye : integer );
      var
         FirstDay,
         LastMaxDay,
         loop        : byte;
      begin
      SetDate(Mo,1,Ye);
      GetDate(Mo,loop,FirstDay,Ye);
      SetDate(Mo,Da,Ye);
      GetDate(Mo,Da,W,Ye);
      gotoxy(1,1);
      TxtColor(White,Blue);
      write(DAY_STR[W]:11,', ',MONTH_STR[Mo],Da:3,',',Ye:5);
      ClrEOL;
      TxtColor(LightGray,Blue);
      gotoxy(1,4);
      Mo := pred(Mo);
      if (Mo = 0) then
         begin
         Mo := 12;
         Ye := pred(Ye);
         if (Ye = 1979) then
            Ye := 2099;
         end;
      LastMaxDay := MaxDays(Mo,Ye);
      GetDate(Mo,Da,W,Ye);
      for loop := (LastMaxDay - pred(FirstDay)) to (LastMaxDay) do
         write(loop:3,' ');
      TxtColor(White,Blue);
      for loop := 1 to MaxDays(Mo,Y) do
         if (loop = Da) then
            begin
            TxtColor(Black,White);
            write(loop:3,' ');
            TxtColor(White,Black);
            end
         else
            write(loop:3,' ');
      TxtColor(LightGray,Blue);
      for loop := 1 to (42 - MaxDays(Mo,Y) - FirstDay) do
         write(loop:3,' ');
      end;

   procedure SetSystemDate;
      begin
      gotoxy(1,1);
      TxtColor(Blue,White);
      ClrEOL;
      write('Setting System Date':24);
      GetDate(MONTH,DAY,W,YEAR);
      delay(2000);
      TxtColor(LightGray,Blue);
      end;

   begin
   if (MONTH = 0) then
      GetDate(MONTH,DAY,M,YEAR);
   GetDate(M,D,W,Y);
   OpenWindo(1,1,30,16,'',LightGray,Blue);
   DrawGrid;
   repeat
      begin
      if (CH in ['S',UP,DOWN,LEFT,RIGHT,PG_UP,PG_DOWN,ESC]) then
         DrawDays(M,D,Y);
      CH := upcase(GetCh(CH));
      case (CH) of
         'S'     : SetSystemDate;
         UP      : if (M = 12) then
                      M := 1
                   else
                      M := succ(M);
         DOWN    : if (M = 1) then
                      M := 12
                   else
                      M := pred(M);
         LEFT    : if (D = 1) then
                      D := MaxDays(M,Y)
                   else
                      D := pred(D);
         RIGHT   : if (D = MaxDays(M,Y)) then
                      D := 1
                   else
                      D := succ(D);
         PG_UP   : if (Y = 2099) then
                      Y := 1980
                   else
                      Y := succ(Y);
         PG_DOWN : if (Y = 1980) then
                      Y := 2099
                   else
                      Y := pred(Y);
         end;
      end;
   until (CH = ESC);
   CloseWindo;
   SetDate(MONTH,DAY,YEAR);
   end;  { Calendar }

begin
Calendar;
end.
