{+-----------------------------------------------------------------------+
 |  GetDate:  returns the current system date as well as a number in-    |
 |            dicating the day of the week.  GetDate accepts four par-   |
 |            ameters each of which MUST be a variable.  The date and    |
 |            day are returned in the parameters in the order month,     |
 |            day, weekday, and year.                                    |
 |                 This procedure is MSDOS 2.1 specific and will only    |
 |  D. Bowen  work with computers supporting this operating system and   |
 |  6/11/86   the 8088 CPU registers.                                    |
 +-----------------------------------------------------------------------+}
procedure GetDate( var Month, Day, WeekDay : byte; var Year : integer );
   var
      Register : RegRec;  { 8088 cpu register type }
   begin
   Register.AH := 42; { function request # }
   MSDOS(Register);   { interrupt 33 (21 Hex) function request }
   with Register do
      begin
      Year    := CX;  { 1980..2099 }
      Month   := DH;  { 1..12 }
      Day     := DL;  { 1..31 }
      WeekDay := AL;  { 0..6  0 = Sunday }
      end;
   end; { Get Date }