const
   MAX_WINDO   = 6;
   WINDO_DEPTH : byte = 0;

type
   ImageType = array [1..2000] of integer;
   WindoRec  = record
                  Image : ImageType;
                  x1, y1,
                  x2, y2,
                  FG,
                  BG,
                  PreX,
                  PreY  : byte;
               end;  { Windo Rec }
   WindoPtr  = ^WindoRec;
var
  CrtMode        : byte      absolute $0040:$0049;
  MonoBuffer     : Imagetype absolute $B000:$0000;
  ColorBuffer    : Imagetype absolute $B800:$0000;
  CrtAdapter     : integer   absolute $0040:$0063;
  VideoMode      : byte      absolute $0040:$0065;
  WindoList      : array [1..MAX_WINDO] of WindoPtr;
  BaseX, BaseY,
  BaseFG, BaseBG : byte;

procedure InitWindo;
   var
      Ch   : char;
      Regs : record
                case boolean of
                   TRUE  : (AX,BX,CX,DX,BP,SI,DI,DS,ES, FLAGS : integer );
                   FALSE : (AL, AH, BL, BH, CL, CH, DL, DH    : byte    );
             end; { Reg Rec }
   begin
   BaseX  := WhereX;
   BaseY  := WhereY;
   FillChar(Regs,SizeOf(Regs),0);
   Regs.AH := 8;                   { request read char/colors   }
   Intr($10,Regs);               { interrupt video            }
   with Regs do
      begin
      BaseFG := ( (AH and 15) + ((AH shr 7) * Blink) );
      BaseBG := ( AH shr 4 and 7 );
      end;
   end;

Procedure VideoOn( Switch: boolean );
   begin
   If (Switch = FALSE) then
      Port[CrtAdapter+4] := (VideoMode - $08)
   else
      Port[CrtAdapter+4] := (VideoMode or $08);
   end;

procedure OpenWindo( Wx1, Wy1, Wx2, Wy2  : byte;
                     Title               : Str80;
                     ForColor, BakColor  : byte  );
   begin
   if (WINDO_DEPTH = MAX_WINDO) then
      begin
      writeln('window''s nested too deep !');
      HALT;
      end;
   if (WINDO_DEPTH = 0) then
      InitWindo;
   WINDO_DEPTH := succ(WINDO_DEPTH);
   new(WindoList[WINDO_DEPTH]);
   with WindoList[WINDO_DEPTH]^ do
      begin
      VideoOn(FALSE);
      if (CrtMode = 7) then
         Image := MonoBuffer
      else
         Image := ColorBuffer;
      VideoOn(TRUE);
      PreX  := WhereX;
      PreY  := WhereY;
      FG    := ForColor;
      BG    := BakColor;
      x1    := Wx1;
      y1    := Wy1;
      x2    := Wx2;
      y2    := Wy2;
      TextColor(FG);
      TextBackground(BG);
      window(1,1,80,25);
      DrawBox(Wx1,Wy1,Wx2,Wy2);
      if (Length(Title) > 0) then
         begin
         if (Length(Title) > x2-x1) then
            Title[0] := chr(x2-x1);
         gotoxy( x1 + ((x2-x1)-succ(Length(Title))) DIV 2,y1);
         write(Title);
         end;
      window(succ(Wx1),succ(Wy1),pred(Wx2),pred(Wy2));
      ClrScr;
      end;  { with windo list }
   end;  { Open Windo }

procedure CloseWindo;
   begin
   if (WINDO_DEPTH > 0) then
      begin
      VideoOn(FALSE);
      with WindoList[WINDO_DEPTH]^ do
         begin
         if (CrtMode = 7) then
            MonoBuffer := Image
         else
            ColorBuffer := Image;
         end;
      VideoOn(TRUE);
      if (WINDO_DEPTH = 1) then
         begin
         window(1,1,80,25);
         gotoxy(BaseX,BaseY);
         TextColor(BaseFG);
         TextBackground(BaseBG);
         end
      else
         begin
         with WindoList[pred(WINDO_DEPTH)]^ do
            begin
            window(succ(x1),succ(y1),pred(x2),pred(y2));
            TextColor(FG);
            TextBackGround(BG);
            end;
         with WindoList[WINDO_DEPTH]^ do
            gotoxy(PreX,PreY);
         end;
      Dispose(WindoList[WINDO_DEPTH]);
      WINDO_DEPTH := pred(WINDO_DEPTH);
      end;
   end;  { Close Windo }
