
const
   MAX_ITEM = 10;

type
   ItemList = array [1..MAX_ITEM] of string[40];
   MenuRec  = record
                 Title     : string[10];  { Menu Title       }
                 Item      : ItemList;    { Display choices  }
                 Choices   : CharSet;     { valid keys       }
                 Ch        : Char;        { chosen key       }
                 ItemCount,               { how many choices }
                 Mx, My,                  { up left corner   }
                 ForColor,                { forground color  }
                 BakColor,                { background color }
                 Width,                   { how wide is menu }
                 Depth,                   { what windo used  }
                 DefltPos,                { deflt position   }
                 CurntPos  : byte;        { curren position  }
                 ExitCh    : char;        { char allows exit }
                 Exit      : boolean;     { exit chosen ?    }
              end;

procedure OpenMenu( var Menu : MenuRec );   {  Open a menu on screen. }
   var                                      {  draw its choices       }
      loop : byte;
   begin
   with Menu do
      begin
      if (Depth = 0) then
         begin
         ItemCount := 0;
         Width  := Length(Title);
         for loop := 1 to MAX_ITEM do
            begin
            if not (Item[loop] = '') then
               begin
               ItemCount := Succ(ItemCount);
               if (Length(Item[loop]) > Width) then
                  Width := Length(Item[loop]);
               end; { if Item blank }
            end; { for }
         OpenWindo( Mx, My, Mx+Width+3, succ(My+ItemCount),
                    Title, ForColor, BakColor );
         Depth := WINDO_DEPTH;
         for loop :=1 to ItemCount do
            begin
            gotoxy(1,loop);
            write(' ',Item[loop]);
            end;
         end; { if depth 0 }
      end; { with }
   end; { Open Menu }

procedure ReadMenu( var Menu : MenuRec );
   const
      MOVEMENT  : CharSet = [UP,DOWN,LEFT,RIGHT,' ','+','-',CR,'4'..'6','8'];
   begin
   with Menu do
      begin
      with WindoList[Depth]^ do
         window(succ(x1),Succ(y1),pred(x2),pred(y2));
      if (CurntPos = 0) then
         if (DefltPos = 0) then
            CurntPos := 1
         else
            CurntPos := DefltPos;
      repeat
         begin
         TxtColor(BakColor,ForColor);
         Select( 1, CurntPos, ' '+Item[CurntPos], Choices+Movement, Ch );
         TxtColor(ForColor,BakColor);
         gotoxy(1,CurntPos);
         ClrEOL;
         write(' ',Item[CurntPos]);
         case (Ch) of
            UP, LEFT, '-', '8', '4'    : CurntPos := Pred(CurntPos);
            DOWN, RIGHT, SPC, '5', '6' : CurntPos := Succ(CurntPos);
            CR, '+'                    : Ch       := chr(CurntPos+ord('0'));
            end; { case }
         if (CurntPos > ItemCount) then
            CurntPos := 1
         else
            if (CurntPos < 1) then
               CurntPos := ItemCount;
         end;
      until (Ch in Choices);
      Exit := (Ch in [ExitCh,ESC]);
      end; { with }
   end; { Get Menu Char }

procedure CloseMenu( var Menu : MenuRec );
   var
      loop : byte;
   begin
   with Menu do
      begin
      if (Depth in [1..WINDO_DEPTH]) then
         begin
         for loop := WINDO_DEPTH downto Depth do
            CloseWindo;
         Depth := 0;
         end;
      end;
   end; { Close Menu }

{ END of Menu.Inc }

