program VecList;

const
   OS : string[50] = '';

type
   RegRec = record           { 8088 CPU registers type definition }
               case boolean of
               TRUE  : (AX,BX,CX,DX,BP,SI,DI,DS,ES, FLAGS : integer );
               FALSE : (AL, AH, BL, BH, CL, CH, DL, DH    : byte    );
            end; { Reg Rec }

var
   Regs     : RegRec;
   TxtFile  : Text;
   loop,
   Seg, Off : integer;


procedure GetVector( Num : byte; var Segment, Offset : integer );
   begin
   Regs.AH := $35;     { request get interrupt vector }
   Regs.AL := Num;     { what interrupt vector to get }
   MsDos(Regs);        { interrupt MsDos              }
   Segment := Regs.ES; { return vector's segment      }
   Offset  := Regs.BX; {                 offset       }
   end;  { Get Interrupt Vector }

begin
write('Name of Operating system: ');
readln(OS);
writeln('Creating ASCII text file VECTOR.ASC');
assign(TxtFile,'VECTOR.ASC');
rewrite(TxtFile);
writeln(TxtFile);
writeln(TxtFile,'Interrupt Vector table for ',OS);
writeln(TxtFile);
writeln(TxtFile,'VECTOR':10,'Segment':10,'OffSet':10);
writeln(TxtFile,'------':10,'-------':10,'------':10);
for loop := 1 to 255 do
   begin
   gotoxy(1,WhereY); write(loop:5);
   GetVector(loop,Seg,Off);
   writeln(TxtFile,loop:10,Seg:10,Off:10);
   end;
writeln(TxtFile,'------':10,'-------':10,'------':10);
close(TxtFile);
end.